Summary:	Lightweight, fast and secure FTP server
Name:		pure-ftpd
Version:	1.0.51
Release:	%mkrel 1
License:	GPL
Group:		System/Servers
URL:		https://www.pureftpd.org/
Source0:	https://download.pureftpd.org/pub/pure-ftpd/releases/%{name}-%{version}.tar.bz2
Source1:	pure-ftpd.service
Source2:	pure-ftpd.logrotate
Source3:	pure-ftpd-xinetd
Source4:	pure-ftpd-avahi.service
Source5:	pure-ftpd.pam-0.77
Source6:        pure-ftpd.pam
Source7:	pure-ftpd-1.0.47-tmpfiles.conf
Patch0:		pure-ftpd.mgaconf.patch
Patch1:		pure-ftpd-1.0.47-fedora-both-options-on-command.patch
Patch2:		pure-ftpd-1.0.47-mga-minuid-1000.patch
Patch3:		pure-ftpd-1.0.47-set-pidfile-path.patch
Provides:	ftp-server ftpserver
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Conflicts:	wu-ftpd, ncftpd, proftpd, anonftp, vsftpd
BuildRequires:	pam-devel
BuildRequires:	openldap-devel
BuildRequires:	mysql-devel
BuildRequires:	postgresql-devel
BuildRequires:	pkgconfig(openssl)

%description
Pure-FTPd is a fast, production-quality, standards-conformant FTP server,
based upon Troll-FTPd. Unlike other popular FTP servers, it has no known
security flaw, it is really trivial to set up and it is especially designed
for modern Linux and FreeBSD kernels (setfsuid, sendfile, capabilities) .
Features include PAM support, IPv6, chroot()ed home directories, virtual
domains, built-in LS, anti-warez system, bandwidth throttling, FXP, bounded
ports for passive downloads, UL/DL ratios, native LDAP and SQL support,
Apache log files and more.

%package 	anonymous
Summary:	Anonymous support for pure-ftpd
Group:		System/Servers
Requires:	pure-ftpd

%description 	anonymous
This package provides anonymous support for pure-ftpd.

%package 	anon-upload
Summary:	Anonymous upload support for pure-ftpd
Group:		System/Servers
Requires:	pure-ftpd

%description 	anon-upload
This package provides anonymous upload support for pure-ftpd.

%prep

%autosetup -p1

# nuke mac files
find -name "\._*" | xargs rm -f

# make README.RPM:

COMPILER="Compiler:               $(gcc -v 2>& 1|tail -1)"
HARDWARE="Hardware platform:      $(uname -m)"
LIBRARY="Library:                $(rpm -q glibc)"
OSVERSION="Linux Kernel:           $(uname -sr)"
PACKAGER="Packager:               %{packager}"
MGARELEASE="Mageia release: $(cat /etc/release)"
RPMVERSION="RPM Version:            $(rpm -q rpm)"

cat <<EOF >>$RPM_BUILD_DIR/%{name}-%{version}/README.RPM
The pure-ftpd rpm packages were created in the following build environment:

$MDKRELEASE
$HARDWARE
$OSVERSION
$LIBRARY
$COMPILER
$RPMVERSION
$PACKAGER

EOF

cp %{SOURCE3} pure-ftpd-xinetd
cp %{SOURCE4} pure-ftpd-avahi.service
cp %{SOURCE6} pure-ftpd.pam

%build
%configure \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --with-paranoidmsg \
    --without-capabilities \
    --with-pam \
    --with-ldap \
    --with-mysql \
    --with-pgsql \
    --with-puredb \
    --without-sendfile \
    --with-altlog \
    --with-cookie \
    --with-diraliases \
    --with-throttling \
    --with-ratios \
    --with-quotas \
    --with-ftpwho \
    --with-welcomemsg \
    --with-uploadscript \
    --with-peruserlimits \
    --with-virtualhosts \
    --with-virtualchroot \
    --with-extauth \
    --with-rfc2640 \
    --with-standalone \
    --with-tls

%make_build

%install
%make_install

install -d -m 755 %{buildroot}%{_mandir}/man8/
install -d -m 755 %{buildroot}%{_sbindir}
install -d -m 755 %{buildroot}%{_unitdir}
install -d -m 755 %{buildroot}%{_rundir}
install -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
install -D -p -m 644 %{SOURCE7} %{buildroot}%{_tmpfilesdir}/%{name}.conf

# Conf
install -m 644 pure-ftpd.conf %{buildroot}%{_sysconfdir}/%{name}
install -m 644 pureftpd-ldap.conf %{buildroot}%{_sysconfdir}/%{name}
install -m 644 pureftpd-mysql.conf %{buildroot}%{_sysconfdir}/%{name}
install -m 644 pureftpd-pgsql.conf %{buildroot}%{_sysconfdir}/%{name}

# Man
install -m 644 man/pure-ftpd.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-ftpwho.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-mrtginfo.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-uploadscript.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-pw.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-pwconvert.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-statsdecode.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-quotacheck.8 %{buildroot}%{_mandir}/man8/
install -m 644 man/pure-authd.8 %{buildroot}%{_mandir}/man8/

install -m 755 %{SOURCE1} %{buildroot}%{_unitdir}/pure-ftpd.service

# Pam
install -d -m 755 %{buildroot}%{_sysconfdir}/pam.d/
install -m 0644 pure-ftpd.pam %{buildroot}%{_sysconfdir}/pam.d/%{name}

# Logrotate
install -d %{buildroot}%{_sysconfdir}/logrotate.d/
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#anonymous ftp
mkdir -p %{buildroot}/var/ftp/pub/
mkdir -p %{buildroot}/var/ftp/incoming/

# xinetd support (tv)
mkdir -p %{buildroot}%{_sysconfdir}/xinetd.d
install -m0644 pure-ftpd-xinetd %{buildroot}%{_sysconfdir}/xinetd.d/pure-ftpd-xinetd

# avahi support (misc)
mkdir -p %{buildroot}%{_sysconfdir}/avahi/services/
install -m0644 pure-ftpd-avahi.service %{buildroot}%{_sysconfdir}/avahi/services/%{name}.service

# Remove unnecessary docs
rm %{buildroot}%{_docdir}/%{name}/README.MacOS-X

%post
%_tmpfilescreate %{name}

# ftpusers creation
if [ ! -f %{_sysconfdir}/ftpusers ]; then
	touch %{_sysconfdir}/ftpusers
fi

USERS="root bin daemon adm lp sync shutdown halt mail news uucp operator games nobody"
for i in $USERS ;do
    cat %{_sysconfdir}/ftpusers | grep -q "^$i$" || echo $i >> %{_sysconfdir}/ftpusers
done

%_post_service pure-ftpd

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service pure-ftpd

%files
%doc FAQ THANKS README.Authentication-Modules README.Virtual-Users
%doc README README.Configuration-File AUTHORS HISTORY NEWS README.LDAP
%doc README.PGSQL README.TLS README.MySQL pure-ftpd.png
%doc pureftpd.schema README.RPM
%doc %{_docdir}/%{name}/*.conf
%{_unitdir}/pure-ftpd.service
%{_tmpfilesdir}/%{name}.conf
%dir %ghost %attr(0644, root, root) %{_rundir}/pure-ftpd
%ghost %attr(0660, -, -) %{_rundir}/pure-ftpd/pure-ftpd.pid

%config(noreplace) %{_sysconfdir}/%{name}/pure-ftpd.conf
%config(noreplace) %{_sysconfdir}/%{name}/pureftpd-ldap.conf
%config(noreplace) %{_sysconfdir}/%{name}/pureftpd-mysql.conf
%config(noreplace) %{_sysconfdir}/%{name}/pureftpd-pgsql.conf
%config(noreplace) %{_sysconfdir}/pam.d/pure-ftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/pure-ftpd
%config(noreplace) %{_sysconfdir}/xinetd.d/pure-ftpd-xinetd
%config(noreplace) %{_sysconfdir}/avahi/services/%{name}.service

%{_bindir}/pure-pw
%{_bindir}/pure-pwconvert
%{_bindir}/pure-statsdecode
%{_sbindir}/pure-ftpd
%{_sbindir}/pure-ftpwho
%{_sbindir}/pure-uploadscript
%{_sbindir}/pure-mrtginfo
%{_sbindir}/pure-quotacheck
%{_sbindir}/pure-authd
%{_sbindir}/pure-certd

%attr(644,root,root)%{_mandir}/man8/*

%files anonymous
%dir /var/ftp/pub/

%files anon-upload
%defattr(777, root, root)
%dir /var/ftp/incoming/



%changelog
* Mon Apr 29 2024 daviddavid <daviddavid> 1.0.51-1.mga10
+ Revision: 2061584
- new version: 1.0.51
- remove merged upstream patches
- switch to systemd unit from initscripts

* Tue Jan 03 2023 umeabot <umeabot> 1.0.47-10.mga9
+ Revision: 1929553
- Rebuild to use libldap-2.5 instead of 2.4

* Sat Apr 02 2022 umeabot <umeabot> 1.0.47-9.mga9
+ Revision: 1841136
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 1.0.47-8.mga9
+ Revision: 1747489
- rebuild for openssl 3.0.0

* Mon Mar 02 2020 pterjan <pterjan> 1.0.47-7.mga8
+ Revision: 1553101
- Add upstream patches for CVE-2019-20176, CVE-2020-9274 and CVE-2020-9365

* Fri Feb 14 2020 umeabot <umeabot> 1.0.47-6.mga8
+ Revision: 1516183
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 1.0.47-5.mga7
+ Revision: 1300407
- Mageia 7 Mass Rebuild

* Sun Feb 11 2018 kekepower <kekepower> 1.0.47-4.mga7
+ Revision: 1200428
- Using _tmpfiles to create the correct path and file
- Added %%{_rundir}/%%{name}/ to hold the pid files

* Sun Feb 11 2018 kekepower <kekepower> 1.0.47-3.mga7
+ Revision: 1200369
- Fixed an issue where pure-ftpd didn't read the config file (mga#22566)
- Added a patch that sets the right pid file
- Fixed startup scripts

* Sun Jan 28 2018 kekepower <kekepower> 1.0.47-2.mga7
+ Revision: 1197870
- Fixed an issue starting pure-ftpd due to a bad command

* Tue Jan 23 2018 kekepower <kekepower> 1.0.47-1.mga7
+ Revision: 1196545
- Update to version 1.0.47
- Ported a patch from Fedora (mga#21783)
- Added a patch to set MinUID to 1000 in pure-ftpd.conf

* Sat Dec 23 2017 wally <wally> 1.0.46-2.mga7
+ Revision: 1184224
- rebuild for new mariadb

* Tue Sep 05 2017 cjw <cjw> 1.0.46-1.mga7
+ Revision: 1151577
- 1.0.46

* Thu Mar 03 2016 umeabot <umeabot> 1.0.42-4.mga6
+ Revision: 983934
- Rebuild for openssl

* Sun Feb 28 2016 oden <oden> 1.0.42-3.mga6
+ Revision: 980346
- rebuilt for postgresql 9.5.x

* Fri Feb 12 2016 umeabot <umeabot> 1.0.42-2.mga6
+ Revision: 958553
- Mageia 6 Mass Rebuild

* Sun Sep 13 2015 pterjan <pterjan> 1.0.42-1.mga6
+ Revision: 878864
- Update to 1.0.42

* Wed Sep 02 2015 luigiwalser <luigiwalser> 1.0.36-7.mga6
+ Revision: 872260
- add patch from fedora to fix DoS issue (mga#16579)

* Tue Nov 25 2014 cjw <cjw> 1.0.36-6.mga5
+ Revision: 798938
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 1.0.36-5.mga5
+ Revision: 746889
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.0.36-4.mga5
+ Revision: 687837
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 1.0.36-3.mga4
+ Revision: 517690
- Mageia 4 Mass Rebuild

* Sun Jan 13 2013 umeabot <umeabot> 1.0.36-2.mga3
+ Revision: 378328
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jul 11 2012 pterjan <pterjan> 1.0.36-1.mga3
+ Revision: 269343
- Update to 1.0.36

* Thu Apr 12 2012 colin <colin> 1.0.35-2.mga2
+ Revision: 230424
- Add LSB headers to initscript (mga#5262)

* Sun Dec 11 2011 pterjan <pterjan> 1.0.35-1.mga2
+ Revision: 180761
- 1.0.35

* Fri Nov 18 2011 pterjan <pterjan> 1.0.34-1.mga2
+ Revision: 168635
- Update to 1.0.34

* Fri May 20 2011 dmorgan <dmorgan> 1.0.32-1.mga1
+ Revision: 99903
- Rename conf patch
  Remove link patch ( fixed in version 1.0.31 )
- New version ( to address CVE-2011-0418 )
  Remove Mandriva words

* Sun May 15 2011 pterjan <pterjan> 1.0.30-2.mga1
+ Revision: 98934
- Rebuild for fixed find-requires

* Thu Apr 14 2011 tv <tv> 1.0.30-1.mga1
+ Revision: 84919
- new release
- patch 1: fix the build with latest mysql (Mikael Andersson)
- add missing requires(*) on rpm-helper
+ ennael <ennael>
- clean spec file

* Sat Feb 26 2011 boklm <boklm> 1.0.29-4.mga1
+ Revision: 60994
- imported package pure-ftpd


* Mon Dec 27 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.29-4mdv2011.0
+ Revision: 625427
- rebuilt against mysql-5.5.8 libs

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.29-3mdv2011.0
+ Revision: 607240
- rebuild

* Wed Apr 07 2010 Funda Wang <fwang@mandriva.org> 1.0.29-2mdv2010.1
+ Revision: 532514
- rebuild

* Tue Mar 16 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.29-1mdv2010.1
+ Revision: 521045
- 1.0.29

* Fri Feb 26 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.28-3mdv2010.1
+ Revision: 511627
- rebuilt against openssl-0.9.8m

* Wed Feb 17 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.28-2mdv2010.1
+ Revision: 507039
- rebuild

* Tue Feb 09 2010 Frederik Himpe <fhimpe@mandriva.org> 1.0.28-1mdv2010.1
+ Revision: 503297
- update to new version 1.0.28

* Sat Dec 05 2009 Oden Eriksson <oeriksson@mandriva.com> 1.0.27-1mdv2010.1
+ Revision: 473775
- 1.0.27

  + Michael Scherer <misc@mandriva.org>
    - add support for tls

* Tue Nov 17 2009 Oden Eriksson <oeriksson@mandriva.com> 1.0.26-1mdv2010.1
+ Revision: 466903
- 1.0.26

* Sat Nov 07 2009 Oden Eriksson <oeriksson@mandriva.com> 1.0.24-1mdv2010.1
+ Revision: 462400
- 1.0.24

* Fri May 01 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.22-1mdv2010.0
+ Revision: 370252
- Update to new version 1.0.22
- Rediff configuration file patch

* Sat Dec 06 2008 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-9mdv2009.1
+ Revision: 311205
- rebuilt against mysql-5.1.30 libs

* Wed Jun 18 2008 Thierry Vignaud <tv@mandriva.org> 1.0.21-8mdv2009.0
+ Revision: 225117
- rebuild

* Mon Dec 24 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-7mdv2008.1
+ Revision: 137491
- fix build (how did it ever build?)
- rebuilt against openldap-2.4.7 libs

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - s/Mandrake/Mandriva/


* Wed Jan 10 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-6mdv2007.0
+ Revision: 107074
- Import pure-ftpd

* Wed Jan 10 2007 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-6mdv2007.1
- bunzip sources and patches
- make it backportable for older pam

* Tue Sep 05 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-1mdv2007.0
- rebuilt against MySQL-5.0.24a-1mdv2007.0 due to ABI changes

* Mon Aug 14 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.21-4mdv2007.0
- misc spec fixes

* Sun Jun 25 2006 Jerome Soyer <saispo@mandriva.org> 1.0.21-3mdv2007.0
- Fix and close #23295

* Thu Jun 22 2006 Jerome Soyer <saispo@mandriva.org> 1.0.21-2mdv2007.0
- Add UTF8 support

* Fri Mar 03 2006 Michael Scherer <misc@mandriva.org> 1.0.21-1mdk
- new version
- use mkrel
- add avahi service description file
- rpmbuildupdatable, with correct url

* Sun Oct 30 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.20-8mdk
- rebuilt against MySQL-5.0.15

* Wed Aug 31 2005 Buchan Milne <bgmilne@linux-mandrake.com> 1.0.20-7mdk
- Rebuild for libldap2.3

* Tue May 10 2005 Buchan Milne <bgmilne@linux-mandrake.com> 1.0.20-6mdk
- Rebuild for postgresql-devel 8.0.2

* Tue Feb 08 2005 Buchan Milne <bgmilne@linux-mandrake.com> 1.0.20-5mdk
- rebuild for ldap2.2_7

* Fri Feb 04 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.20-4mdk
- rebuilt against new openldap libs

* Tue Jan 25 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.20-3mdk
- rebuilt against MySQL-4.1.x and PostgreSQL-8.x system libs

* Tue Jul 27 2004 Pascal Terjan <pterjan@mandrake.org> 1.0.20-2mdk
- Enable large file support
- Drop useless provide pure-ftpd

* Tue Jul 27 2004 Pascal Terjan <pterjan@mandrake.org> 1.0.20-1mdk
- 1.0.20

* Tue Apr 20 2004 Laurent Culioli <laurent@mandrake.org> 1.0.18-1mdk
- 1.0.18

